![](https://i.postimg.cc/NGX6X6GP/image.png)

[中文版本](./README.md) | [English Version](./README-en.md)

# 某熊的技术之路指北 ☯

在这个知识大爆发的时代，笔者所见许多人面临的问题不再是知识的匮乏，也不是缺乏学习的动力、毅力或激情，而是在浩汤洪流之中迷失了方向，也无足够的承载知识的容器，终致学的越多，忘的越多，竹篮打水一场空。[某熊的技术之路](https://github.com/wx-chevalier)系列文章/书籍/视频/代码即是笔者为自己构建的**知识围栏**，纳知识与己内；也是笔者蹒跚行进于这条路上的点滴印记，包含了笔者作为程序员的技术视野、知识管理与职业规划，致力于提升开发者的学习效率与实际研发效能。

目前笔者已有数十仓库千篇文章百万字，你可以在[某熊的技术之路指北 ☯](https://github.com/wx-chevalier/Developer-Zero-To-Mastery)查阅详细的导航。可以前往 [Awesome Lists](https://ngte-al.gitbook.io/i/) 或者 [Awesome-CS-Books](https://github.com/wx-chevalier/Awesome-CS-Books) 查阅分门别类的资料与书籍，抑或前往 [Awesome MindMaps](https://github.com/wx-chevalier/Awesome-MindMaps) 查阅完整的知识体系、脉络与要点的脑图，或者 [Awesome RoadMaps](https://github.com/wx-chevalier/Awesome-RoadMaps) 了解不同技术领域的进阶指南。最后，你还可以前往 [Awesome Interviews](https://github.com/wx-chevalier/Awesome-Interviews) 做最后面试前的准备，或者用常见的技术面试题去检验自己学习的结果。

# Nav | 导航

[某熊的技术之路指北 ☯ ](https://github.com/wx-chevalier/Developer-Zero-To-Mastery)就是对笔者不同领域方面沉淀下的知识仓库的导航与索引，便于读者快速地寻找到自己需要的内容。路漫漫其修远兮，吾正上下而求索，也希望能给所有遇见过笔者痕迹的同学些许帮助，在浩瀚银河间能顺利达到一个又一个彼岸。Just Coder，Travel in Galaxy，欢迎关注[某熊的技术之路](https://i.postimg.cc/mDxdH0VL/image.png)公众号，让我们一起前行。

![技术视野](https://s2.ax1x.com/2019/09/30/uJWQTx.jpg)

您可以通过以下导航来在 Gitbook 中阅读笔者的系列文章，涵盖了技术资料归纳、编程语言与理论、Web 与大前端、服务端开发与基础架构、云计算与大数据、数据科学与人工智能、产品设计等多个领域：

- 知识体系：《[Awesome Lists | CS 资料集锦](https://ngte-al.gitbook.io/i/)》、《[Awesome CheatSheets | 速学速查手册](https://ngte-ac.gitbook.io/i/)》、《[Awesome Interviews | 求职面试必备](https://github.com/wx-chevalier/Awesome-Interviews)》、《[Awesome RoadMaps | 程序员进阶指南](https://github.com/wx-chevalier/Awesome-RoadMaps)》、《[Awesome MindMaps | 知识脉络思维脑图](https://github.com/wx-chevalier/Awesome-MindMaps)》、《[Awesome-CS-Books | 开源书籍（.pdf）汇总](https://github.com/wx-chevalier/Awesome-CS-Books)》

- 编程语言：《[编程语言理论](https://ngte-pl.gitbook.io/i/)》、《[Java 实战](https://github.com/wx-chevalier/Java-Series)》、《[JavaScript 实战](https://github.com/wx-chevalier/JavaScript-Series)》、《[Go 实战](https://ngte-pl.gitbook.io/i/go/go)》、《[Python 实战](https://ngte-pl.gitbook.io/i/python/python)》、《[Rust 实战](https://ngte-pl.gitbook.io/i/rust/rust)》

- 软件工程、模式与架构：《[编程范式与设计模式](https://ngte-se.gitbook.io/i/)》、《[数据结构与算法](https://ngte-se.gitbook.io/i/)》、《[软件架构设计](https://ngte-se.gitbook.io/i/)》、《[整洁与重构](https://ngte-se.gitbook.io/i/)》、《[研发方式与工具](https://ngte-se.gitbook.io/i/)》

* Web 与大前端：《[现代 Web 全栈开发与工程架构](https://ngte-web.gitbook.io/i/)》、《[数据可视化](https://ngte-fe.gitbook.io/i/)》、《[iOS](https://ngte-fe.gitbook.io/i/)》、《[Android](https://ngte-fe.gitbook.io/i/)》、《[混合开发与跨端应用](https://ngte-fe.gitbook.io/i/)》

* 服务端开发实践与工程架构：《[服务端基础](https://ngte-be.gitbook.io/i/)》、《[微服务与云原生](https://ngte-be.gitbook.io/i/)》、《[测试与高可用保障](https://ngte-be.gitbook.io/i/)》、《[DevOps](https://ngte-be.gitbook.io/i/)》、《[Spring](https://github.com/wx-chevalier/Spring-Series)》、《[信息安全与渗透测试](https://ngte-be.gitbook.io/i/)》

* 分布式基础架构：《[分布式系统](https://ngte-infras.gitbook.io/i/)》、《[分布式计算](https://ngte-infras.gitbook.io/i/)》、《[数据库](https://github.com/wx-chevalier/Database-Series)》、《[网络](https://ngte-infras.gitbook.io/i/)》、《[虚拟化与云计算](https://github.com/wx-chevalier/Cloud-Series)》、《[Linux 与操作系统](https://github.com/wx-chevalier/Linux-Series)》

* 数据科学，人工智能与深度学习：《[数理统计](https://ngte-aidl.gitbook.io/i/)》、《[数据分析](https://ngte-aidl.gitbook.io/i/)》、《[机器学习](https://ngte-aidl.gitbook.io/i/)》、《[深度学习](https://ngte-aidl.gitbook.io/i/)》、《[自然语言处理](https://ngte-aidl.gitbook.io/i/)》、《[工具与工程化](https://ngte-aidl.gitbook.io/i/)》、《[行业应用](https://ngte-aidl.gitbook.io/i/)》

* 产品设计与用户体验：《[产品设计](https://ngte-pd.gitbook.io/i/)》、《[交互体验](https://ngte-pd.gitbook.io/i/)》、《[项目管理](https://ngte-pd.gitbook.io/i/)》

* 行业应用：《[行业迷思](https://github.com/wx-chevalier/Business-Series)》、《[功能域](https://github.com/wx-chevalier/Business-Series)》、《[电子商务](https://github.com/wx-chevalier/Business-Series)》、《[智能制造](https://github.com/wx-chevalier/Business-Series)》

此外，你还可前往 [xCompass](https://wx-chevalier.github.io/home/#/search) 交互式地检索、查找需要的文章/链接/书籍/课程；或者在 [MATRIX 文章与代码索引矩阵](https://github.com/wx-chevalier/Developer-Zero-To-Mastery)中查看文章与项目源代码等更详细的目录导航信息。最后，你也可以关注微信公众号：『**某熊的技术之路**』以获取最新资讯。

# 编程之道，从代码到软件系统

十年前，当笔者写下第一行 Hello World 时，仿佛已经抓住了整个世界；十年后，我还是在门口徘徊。本节主要以感性地方式去讨论笔者思索的，所谓编程到底难在哪，这个 “Little Problem”。

## 语言、范式与模式

> Programmers who program “in” a language limit their thoughts to constructs that the language directly supports. If the language tools are primitive, the programmer’s thoughts will also be primitive.
>
> Programmers who program “into” a language first decide what thoughts they want to express, and then they determine how to express those thoughts using the tools provided by their specific language.
>
> -- Steve McConnell’s Code Complete

在笔者过去的工作中，曾经多次被语言“绑架”而导致在技术选型上的巨大失败，最终衍化为了产品、商业竞争力上的乏力。

多范式编程（Multi-Paradigm Programming）和最小表达力原则（Least Expressiveness Principle）

## 架构与复杂性控制

## 性能与高可用

首先是算法。

## 研发效能

# MATRIX | 文章与代码源矩阵

[![image.png](https://i.postimg.cc/y1QXgJ6f/image.png)](https://postimg.cc/bZFSQcfz)

- 知识检索、资料归档、实践清单

| [Developer-Zero-To-Mastery](https://github.com/wx-chevalier/Developer-Zero-To-Mastery) | [Awesome-Lists](https://github.com/wx-chevalier/Awesome-Lists) | [Awesome-CheatSheets](https://github.com/wx-chevalier/Awesome-CheatSheets) | [Awesome-CS-Books](https://github.com/wx-chevalier/Awesome-CS-Books) | [Awesome-Interviews](https://github.com/wx-chevalier/Developer-Zero-To-Mastery) |
| -------------------------------------------------------------------------------------- | -------------------------------------------------------------- | -------------------------------------------------------------------------- | -------------------------------------------------------------------- | ------------------------------------------------------------------------------- |


| [xCompass](https://github.com/wx-chevalier/xCompass) |
| ---------------------------------------------------- |


- 编程语言理论与实践

| [ProgrammingLanguage Theory Primer/编程语言理论指南](https://github.com/wx-chevalier/ProgrammingLanguage-Series/blob/master/编程语言理论) | [JavaScript 篇](https://github.com/wx-chevalier/ProgrammingLanguage-Series/blob/master/JavaScript) | [Java 篇](https://github.com/wx-chevalier/ProgrammingLanguage-Series/blob/master/Java) | [Python 篇](https://github.com/wx-chevalier/ProgrammingLanguage-Series/blob/master/Python) | [Go 篇](https://github.com/wx-chevalier/ProgrammingLanguage-Series/blob/master/Go) | [Rust 篇](https://github.com/wx-chevalier/ProgrammingLanguage-Series/blob/master/Rust) |
| ----------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------ | ---------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------- |


- 软件工程、数据结构与算法、设计模式、软件架构

| [数据结构与算法](https://github.com/wx-chevalier/SoftwareEngineering-Series/blob/master/数据结构与算法) | [面向对象的设计模式](https://github.com/wx-chevalier/SoftwareEngineering-Series/blob/master/面向对象的设计模式) | [整洁与重构](https://github.com/wx-chevalier/SoftwareEngineering-Series/blob/master/整洁与重构) | [软件架构设计](https://github.com/wx-chevalier/SoftwareEngineering-Series/blob/master/软件架构设计) | [研发方式与工具](https://github.com/wx-chevalier/SoftwareEngineering-Series/blob/master/研发方式与工具) |
| ------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------- |


| [algorithm-snippets](https://github.com/wx-chevalier/algorithm-snippets) | [design-pattern-snippets](https://github.com/wx-chevalier/design-pattern-snippets) |
| ------------------------------------------------------------------------ | ---------------------------------------------------------------------------------- |


- 现代 Web 全栈开发与工程架构

| [基础篇](https://github.com/wx-chevalier/Web-Series/blob/master/基础) | [工程实践篇](https://github.com/wx-chevalier/Web-Series/blob/master/工程实践) | [架构优化篇](https://github.com/wx-chevalier/Web-Series/blob/master/架构优化篇) | [React 篇](https://github.com/wx-chevalier/Web-Series/blob/master/React) | [Vue 篇](https://github.com/wx-chevalier/Web-Series/blob/master/Vue) |
| --------------------------------------------------------------------- | ----------------------------------------------------------------------------- | ------------------------------------------------------------------------------- | ------------------------------------------------------------------------ | -------------------------------------------------------------------- |


- 大前端混合开发与数据可视化

| [iOS 实战篇](https://github.com/wx-chevalier/Frontend-Series/blob/master/iOS) | [Android 实战篇](https://github.com/wx-chevalier/Frontend-Series/blob/master/Android) | [Hybrid 混合开发篇](https://github.com/wx-chevalier/Frontend-Series/blob/master/Hybrid) | [数据可视化篇](https://github.com/wx-chevalier/Frontend-Series/blob/master/DataVisualization) | [IoT 实战篇](https://github.com/wx-chevalier/Frontend-Series/blob/master/IoT) |
| ----------------------------------------------------------------------------- | ------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------- |


- 服务端开发

| [服务端应用程序开发基础](https://github.com/wx-chevalier/Backend-Series/blob/master/服务端基础) | [微服务与云原生](https://github.com/wx-chevalier/Backend-Series/blob/master/微服务与云原生) | [深入浅出 Node.js 全栈架构](https://github.com/wx-chevalier/Backend-Series/blob/master/Node) | [Spring Boot 5 与 Spring Cloud 微服务实践](https://github.com/wx-chevalier/Backend-Series/blob/master/Spring) | [DevOps 与 SRE 实战](https://github.com/wx-chevalier/Backend-Series/blob/master/DevOps) | [信息安全与渗透测试必知必会](https://github.com/wx-chevalier/Backend-Series/blob/master/信息安全与渗透测试) | [测试与高可用保障](https://github.com/wx-chevalier/Backend-Series/blob/master/测试与高可用保障) |
| ----------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------- |


- 分布式基础架构

| [Linux 与操作系统篇](https://github.com/wx-chevalier/Distributed-Infrastructure-Series/blob/master/Linux%20与操作系统) | [分布式计算篇](https://github.com/wx-chevalier/Distributed-Infrastructure-Series/blob/master/分布式计算) | [虚拟化与编排篇](https://github.com/wx-chevalier/Distributed-Infrastructure-Series/blob/master/虚拟化与编排) | [分布式系统篇](https://github.com/wx-chevalier/Distributed-Infrastructure-Series/blob/master/分布式系统) | [数据库篇](https://github.com/wx-chevalier/Distributed-Infrastructure-Series/blob/master/数据库) |
| ---------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------ | -------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------ |


- 数据科学、人工智能、机器学习、深度学习、自然语言处理

| [数理统计篇](https://github.com/wx-chevalier/AIDL-Series/blob/master/数理统计) | [数据分析篇](https://github.com/wx-chevalier/AIDL-Series/blob/master/数据分析) | [机器学习篇](https://github.com/wx-chevalier/AIDL-Series/blob/master/机器学习) | [深度学习篇](https://github.com/wx-chevalier/AIDL-Series/blob/master/深度学习) | [自然语言处理篇](https://github.com/wx-chevalier/AIDL-Series/blob/master/自然语言处理) |
| ------------------------------------------------------------------------------ | ------------------------------------------------------------------------------ | ------------------------------------------------------------------------------ | ------------------------------------------------------------------------------ | -------------------------------------------------------------------------------------- |


| [推荐系统等行业应用篇](https://github.com/wx-chevalier/AIDL-Series/blob/master/行业应用) | [课程笔记篇](https://github.com/wx-chevalier/AIDL-Series/blob/master/课程笔记) | [TensorFlow & PyTorch 等工具实践篇](https://github.com/wx-chevalier/AIDL-Series/blob/master/工具实践) |
| ---------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------ | ----------------------------------------------------------------------------------------------------- |


- 产品与设计

| [产品设计篇](https://github.com/wx-chevalier/Product-Series/blob/master/产品设计) | [交互体验篇](https://github.com/wx-chevalier/Product-Series/blob/master/交互体验) | [项目管理篇](https://github.com/wx-chevalier/Product-Series/blob/master/项目管理) | [文档处理篇](https://github.com/wx-chevalier/Product-Series/blob/master/文档处理) | [行业迷思篇](https://github.com/wx-chevalier/Product-Series/blob/master/行业迷思) | [智能制造篇](https://github.com/wx-chevalier/Product-Series/blob/master/智能制造) | [电子商务篇](https://github.com/wx-chevalier/Product-Series/blob/master/电子商务) |
| --------------------------------------------------------------------------------- | --------------------------------------------------------------------------------- | --------------------------------------------------------------------------------- | --------------------------------------------------------------------------------- | --------------------------------------------------------------------------------- | --------------------------------------------------------------------------------- | --------------------------------------------------------------------------------- |


# Copyright | 版权

![](https://parg.co/bDY) ![](https://parg.co/bDm)

![](https://i.postimg.cc/TYs7KDk4/image.png)

笔者所有文章遵循[知识共享 署名 - 非商业性使用 - 禁止演绎 4.0 国际许可协议](https://creativecommons.org/licenses/by-nc-nd/4.0/deed.zh)，欢迎转载，尊重版权。如果觉得本系列对你有所帮助，欢迎给我家布丁买点狗粮(支付宝扫码)~

![](https://i.postimg.cc/y1QXgJ6f/image.png?raw=true)
