不想努力，很可能你正在被“体验自我”所主导。

什么是体验自我，被它主导会如何？

著名心理学家 Daniel Kahneman 提出，每个人都有两个自我：“体验自我”和“记忆自我”。体验自我，是那个亲身经历着我们人生的自己，是每时每刻的直接体验。但由于我们的一生中有太多个瞬间，所以活在当下的体验自我是没有记忆能力的。因此，我们会“好了伤疤忘了疼”，也会贪图眼前的快乐。对于体验自我而言，幸福就是每一个当下的感官体验的满足。

被体验自我所主导又会有什么问题？那很可能就是——让我们失去目标，永远停留在自己的舒适区。不想努力换句话说就是想停留在舒适区。Alasdair White 在 2009 年这么定义“舒适区”：人把自己的行为限定在一定的范围内，Ta 对这个范围内的人事都非常熟悉，从而有把握保持稳定的行为表现。在舒适区里，“我们的不确定、匮乏和脆弱都降到最低，我们认为自己拥有足够的爱、食物、才能、时间，能够获得足够的欣赏，我们能感受到自己的控制力。”(Brown, 2010)

拖延，懒惰，贪婪……这些都与强大的体验自我密切相关，它常常破坏记忆自我完美的计划。比如，我们的记忆自我可能在新年伊始时定下了很多有意义的目标——要多看书，要学一门新语言，要每天去健身房运动。但在要实施时，贪图及时享乐与安逸的体验自我就会让我们偷懒、懈怠，最终一事无成。

长远来看，过于注重及眼前的舒适和欢愉，会让我们不愿，甚至不敢尝试任何会让自己承受一点痛苦或不适的挑战，永远无法踏出自己的舒适区。渐渐地，“活在当下”，“珍惜眼前”变成了用来暂时性逃避未来的借口。

如果你也被体验自我所主导而不想努力，该怎么办？

1．需要意识到这种享乐主义可能会给人带来的危害

首先最为严重的危害会是让我们的身体变得更差。Cole 和 Fredrickson 发现，生活得很快乐、但几乎不追求人生的意义的人，和那些“长期身处逆境的人”的基因表达模式非常相似。这些处于被 Fredrickson 称作“空洞的积极情绪”（Empty positive

emotions）的快乐状态的人，身体却一直在做好预防细菌威胁的准备，促炎反应会变得活跃。也就是说，即便他们并未患病，身体也会先调动自己处于一种“炎性反应状态”，以抵御可能会患病的风险。如此，处于长期炎性状态的身体，罹患心脏病和癌症的风险将会更高。

其次就是无法实现想要完成的目标。一个人留在舒适区里的时间越长，难以改变的惰性越大。勇气往往是一鼓作气的，太久的不成长，会不断削减一个人对自己的信心。

2.找到改变的动机

其实题主在问出“该怎么化解”的时候，一定程度上反应了自己打算转变的念头，这个时候，需要找到动机，助力一把。

在改变的过程中，为什么有的人很容易放弃或厌倦？有的人则会把不断地拓宽舒适区变成一种习惯，日复一日地向着“更好的自己”的目标前进？

James Prochaska 关于改变的阶段变化模型中，还强调了内在因素对行为改变的重要作用。在改变的阶段中，有一个自始至终影响行为改变的深层推动力——动机。

动机是什么？从字面意思上说，它指的是“想要做某件事的动力”。在心理学中，它是一种内在的驱动力，会影响到行为的几大要素——发端、方向、强度和持续性，使你向着目标不断前进。动机对于目标的设定和达成至关重要：它受到人心理上对目标的渴望程度的影响，但它能够维持人们追求目标的行为。

佛罗里达州立大学教授 Anders Ericsson 称，动机是成就的关键因素，那些成功的人之所以成功，很多时候只是因为在某些事上，保持了比其他人更持久和强烈的动机。他认为，你在一件事情上做得越久，你的天赋和能力就会变得越不重要，相反，动机的影响会变得越来越重要。

20 世纪以来，动机逐渐成为心理学家的研究对象，著名的马斯洛需求层次理论就是动机的一种理论模型。一般来说，从来源上，研究者们都会把动机分为内在动机和外在动机。内在动机是指来自自己内心的动机，外在动机是指来自外部世界的动机。

此外，研究者还把动机分为正向、反向两种。正向动机是指以鼓励、认可、肯定等正面情绪主导的动机；负向动机则是以贬损、羞辱、威胁、不安全等负面情绪主导的动机。

结合上述两个维度，动机一共可以分为四种，它们都能以不同的方式影响我们的行为，驱动我们做出改变。

· 内在 - 正向的（Internal-positive）动机：发自内心的、鼓励我们做出积极行为的动机，比如挑战、期望、激情、满足感、自我确认；它往往能够给我们带来内心的成就感、价值感，使我们完成和巩固整个行为改变的过程。

· 外在 - 正向的（External-positive）动机: 被外在的好处驱动，比如被他人欣赏和承认，有经济上的奖励；它可能会带来一些行为改变，产生部分成就感，但影响力往往是短暂的，影响范围是狭窄的。行为能否持续、以及是否能一直带来积极的情绪，依赖于他人或外界给予的奖赏、好处。

· 内在 - 反向的（Internal-negative）动机：被内心负面的感觉所驱动，比如感到威胁、害怕失败、空虚感和不安全感；它可能会带来一些行为改变，但可能进入复发阶段。

· 外在 - 反向的（External-negative）动机：被外界可能的不良影响所驱动，比如可能不被他人给予足够的尊重，有经济或人际上的压力，来自对自己非常重要的人的压力，不稳定的生活等等。它可能会使人成功，但非常有可能进入复发阶段（被逼着做出的改变都很容易复发）。

在四种动机中，内在 - 正向的动机是最理想的，它会使你的目标更坚定，行为更持久，因为这种驱动力来自于你自身的强大与安全感。

3. 当你找到了改变的动机，你可以制定一些具体的行动计划

改变不是一蹴而就的，它需要你评估自己的状态和阶段，然后一步步地、有针对性地推进。

（1）请周围人帮忙监督

题主正处于意向阶段（Contemplation）：也称为“打算转变”（Getting Ready）阶段。此时，您意识到了行为存在的问题，同时也能够明白改变可能带来的好处，有计划在未来 6 个月内行动，但同时意识到改变会有一些困难障碍。请周围人帮忙监督有助于您下决心要改变。 不仅如此，在接下来的准备阶段（Preparation）：也称为“准备转变”（Ready）阶段。此时个体已经下定决心要改变，且已经打算近期就改变自己的行为；还有行动阶段（Action）：这个阶段是指在过去的 6 个月内，行为已经开始有所改变。在这个阶段，个体需要大量的社会支持，周围人帮忙监督可以经常对 Ta 强调长期坚持的好处。

（2）学会保持巩固

新的行为已经持续 6 个月以上，改变已经发生了，但在这个保持巩固阶段，您仍然需要长期坚持，预防旧问题的复发。

（3）预防复发

人的行为随时随地都有返回至原先状态的可能。如果进入了复发阶段，就应该评价复发的原因，重新评估改变的动机和障碍，提前采取更强的干预措施。
