﻿- [某熊的阅读与写作日常](https://zhuanlan.zhihu.com/p/25191664)  从属于 [程序熊的自我修养](https://github.com/wx-chevalier/Coder-Knowledge-Graph/tree/master/I-AM-Coder)

最近加入了 InfoQ 的社区编辑，负责一些线索搜寻与文章翻译，突然想写一篇文章记录下我的日常生活中的阅读与写作模式。一年多以来基本上所有的文章都是希望纯技术主题的；突然也想整理一个系列来讲讲个人对于技术的不严谨的看法与感悟，不敢妄称程序员，就叫[程序熊的自我修养](https://github.com/wx-chevalier/Coder-Knowledge-Graph/tree/master/I-AM-Coder)吧，可能会包含以下部分：
- 【程序熊的自我修养】我写代码这三年
- 【程序熊的自我修养】知识体系与自我定位
- 【程序熊的自我修养】阅读与积累
- 【程序熊的自我修养】工具与实战
- 【程序熊的自我修养】产品与工程化
- 【程序熊的自我修养】编程之道：编程语言、数据结构与算法、编程范式
- 【程序熊的自我修养】Web 前端
- 【程序熊的自我修养】服务端应用程序架构
- 【程序熊的自我修养】数据科学与人工智能

言归正传，本文我希望来描述下每日的阅读与写作模式，重点是阅读的来源与使用的工具。首先需要强调的是，因为本文是日常阅读，所以并不会包括类似于 SICP，CSAPP 这样的大部头。笔者目前兼职于某建筑行业软件公司，公司业务包括交易平台、交易 APP、数据管理中心、数据分析报告等；笔者负责技术团队的日常运作，整个技术团队大约十个人；早期会负责产品架构与核心代码开发，不过随着日趋稳定笔者每天只是在现场打酱油。笔者这个阶段最主要的任务还是毕业论文，暂且把毕业论文与公司归为工作一类；总体来说笔者每日在工作与阅读学习上的时间开支正好对半分。

每天早上骑着小电驴和妹子(妹子是公司的产品经理)一起到公司之后，笔者首先会浏览下文章列表，然后将感兴趣的文章添加到 [Pocket](https://getpocket.com) 中；如果是类似于 [Deeplearning Textbook](https://exacity.github.io/deeplearningbook-chinese/Chapter1_introduction/) 这样的在线书籍或者 CS224D 这样的课程会加入到 [Chrome](https://chrome.google.com)书签中。然后在 iPad、手机上都可以随时同步 Pocket 与 Chrome 中的阅读记录与书签，Pocket 还支持离线阅读，都是非常推荐的应用。笔者在早期主要是刷中文社区，现在的话主要以英文文章为主，这里就涉及到所谓的科学上网的问题了。笔者推荐 [Shadowsocks](https://shadowsocks.org/) 或者 [云墙](netfits.io) 作为辅助，在 iPad 中可以使用 [Shadowrocket](https://itunes.apple.com/us/app/shadowrocket/id932747118?mt=8) ，Android 中可以使用影梭，都是不错的工具。
笔者每天首先会刷一波资讯阅读类网站，包括但不限于：

- [Reddit](https://www.reddit.com/)，可以订阅一些感兴趣的主题。

- [Regular Geek](http://regulargeek.com/)，每日资讯合集。

- [MyBridge](https://www.mybridge.co/todaytop)，可以订阅一些感兴趣的主题。

- [Github Trending](https://github.com/trending)

- [Twitter](https://twitter.com/)，可以 Follow 一些大牛获取一手信息。

- [Medium](https://medium.com/)，这是笔者每日浏览最多的网站了，目前也是笔者认为质量最高的站点之一。

然后中文社区的话推荐[推酷](http://www.tuicool.com/a/)，[开发者头条](toutiao.io)与[掘金](https://gold.xitu.io/new-entry)。还有一些公众号与个人博客笔者这里就暂不推荐了，基本上可以从上面这些聚合阅读类网站里面也可以发现。之前有不少可能是刚入门的同学讨论应该怎么学习，从我个人经历而言，我最初就是刷推酷每日推荐文章。大概每天会浏览 100 篇左右，最初的时候真的蛮痛苦的，看啥啥不会；不过过了一段时间这种填鸭式的阅读还是有一定效果的，能够帮你建立相对完善全面的技术体系世界观(笔者的[2016-我的技术之路:编程知识体系结构](https://zhuanlan.zhihu.com/p/24476917)就是从那时开始的)。等到某一天你可能浏览了数百篇文章但是发现只有一两篇有兴趣一读的，那么就可以开始多啃啃大部头了。

阅读只是前行的第一个准备，下面我们需要能够将阅读到的知识沉淀下来，也就是所谓的笔记与写作。对于写作工具笔者考量过[为知笔记](www.web-wiz.com)，有道笔记，印象笔记等，不过笔者的基本需求包括:

- 允许自定义多层目录结构，这样的话才方便将合适的笔记放置到合适的地方。
- 允许 MarkDown。
- 支持 LaTeX 数学表达式。

综合考量之下貌似只有为知笔记符合以上三个需求。笔记是对于自己知识的积累与总结，而写作则能帮助你打造个人品牌，提升社区影响力，并且能让你的知识经过更多的批判与讨论，非常有助于个人的成长。初期能力不足的话建议以翻译为主，上文笔者推荐的不少每日阅读网站都是英文阅读网站，可以选取感兴趣的文章进行翻译。笔者最早是在 CSDN 博客进行写作的，不过老实说体验不是很好。后来笔者迁到了[SegmentFault-某熊的全栈之路](https://segmentfault.com/blog/wx-chevalier)与[知乎-某熊的全栈之路](https://zhuanlan.zhihu.com/wx-chevalier)，这两个网站的用户体验，SEO 以及 读者沉淀做的都不错，值得一试。文章写好了之后我们自然希望能有更多的人阅读，做过互联网营销的相信都非常熟悉所谓的分享渠道，而我们也需要主动地将自己的文章分享到渠道中；笔者常用的渠道包括：

- CSDN 极客头条，有 Chrome 插件
- SegmentFault 头条
- 开发者头条
- Gank.io
- 掘金
- 技术头条
- 奇舞周刊

最后还想说一句，如果有什么笔者未提及的渠道欢迎告知~
