[![返回目录](https://i.postimg.cc/50XLzC7C/image.png)](https://github.com/wx-chevalier/Web-Series)

# 2018-我的技术之路: 做些有趣的产品

年初的时候，我就在想，今年的主题词是什么；上半年考虑的较多的是所谓**研发效能的提升**，下半年却渐渐发现自己更多的会在想**产品**这两个字。从代码出发，在写代码的时候会想到模块/库/框架/平台等等概念，但是突兀地发现好像从未想过，做的任何东西都是产品。印象深刻的 Case 就是浏览了 [Don’t Make Me Think](https://parg.co/64R) 及其他书籍之后，慢慢发现自己之前无论是写页面（譬如[个人主页](http://wx-chevalier.github.io)）、PPT 还是论文，都推崇草蛇灰线，却是极大地违反了受众的习惯；为了勉励自己能在 2019 年更加的下沉到产品思考，就将本文重定位为，**做些有趣的产品**。

# Github，知识检索与知识图谱

今年投入精力较多的算是对于笔记/代码的重整合，使得各个模块、脉络更为清晰，也方便外化。偶尔会瞅瞅 Github 的总 Star 数，不知不觉终于要破万了，这种行为没啥大意义，但是会告诉我生活不止眼前的苟且或磅礴，还有属于自己的路。阅读，写作，编程本身就是乐趣，而不仅仅是他们的结果。生，活不难，生活却艰难，给人生多**几个坐标，几个赛道**也是舒缓压力不错的方式。我的 [Github 知识类仓库](https://github.com/wx-chevalier)，大概分为如下几部分：

![default](https://user-images.githubusercontent.com/5803001/50385677-2996cd80-0714-11e9-8f7f-55945c435375.png)

前几年喜欢强调对于**资讯的掌握程度**，以逛各种聚合阅读、博客为主，虽然想着要系统化学习，却不可否认地在这里逡巡还是只能窥冰山一角，还是需要阅读大部头的书籍，完整地学习某些课程或者自己从零开始造些玩具轮子。笔者开始降低每日的阅读量，而是尝试改为专题式的学习，每周可以定一个 Topic，专注地，不贪多贪全地去学习。这里 [Awesome-CS-Books](https://github.com/wx-chevalier/Awesome-CS-Books) 存放了笔者阅读过的书籍以及书摘，而 [InfraS-Wheels](https://github.com/wx-chevalier/InfraS-Wheels) 则是希望能够在重造轮子的过程中，提升自己的基础掌握与代码实践能力。

为了方便检索，我也特地重构了[个人主页](http://wx-chevalier.github.io)，把知识图谱、知识架构与知识检索结合到了一起：

![image](https://user-images.githubusercontent.com/5803001/50374921-2b876080-0630-11e9-87b1-ef3fea261324.png)

不得不说，这个个人主页做的极烂，极大地违反了 Don’t Make Me Think 这个原则。交互并不限于界面，应该是完整的用户流程；虽然笔者用了 PWA/Web Worker 等些许的优化手段，网页搜索的响应，包括每次需要打开浏览器，而无法 One Stop 一键直达等性质，让我选择自建了 [alfred-sg](https://parg.co/6Vs) 这个工具：

![](https://user-images.githubusercontent.com/5803001/50546216-fd70d480-0c5e-11e9-9b6b-cceaf7860c58.png)

可以先在 MAC 上安装效率神器 [Alfred](https://xclient.info/s/alfred.html)，然后直接使用 NPM 安装即可：

```sh
$ npm install -g alfred-sg
```

欢迎使用，欢迎 [ISSUE](https://github.com/wx-chevalier/xCompass/issues)。做了许久的 MD 工程师，不知道何时能晋升到高级 MD 工程师。

# 数据浪潮之间的前端工程师

现在是专门做前端的工程师，却感觉自己离前端愈来愈远；今年唯一与前端相关的总结就是[数据浪潮之间的前端工程师](https://parg.co/6KA)了吧，写完自己却觉得索然无味。数据浪潮之后，有 Web 前端、数据富集与处理、人工智能，自己却更像 API 调用工程师，针对不同的业务场景选择合适的 API，选择合适的模型。

这里不再赘述，笔者还是想随意说些其他的前端感想：

- **No Warning**，在编写 JS/TS 项目时习惯了不放过任一的 ESLint/TSLint Warning, 很多 Bug 就隐藏在 Warning 之下。

- **面向重构编程**，使用 ts；拥抱变化，项目之处的很多规划、设计、业务可能都会改变，不畏变化，随时重构。

- **圆角，阴影，边距**，良好的交互源于细节，产品不仅仅可用就好。

- **恰到好处地主动优化**，平衡用户体感，业务价值与自我排期；过度/提前优化也是万恶之源。

- **用产品思维做技术**，用技术赋能产品。

- **GraphQL 并非银弹**，不建议直接替换客户端的状态管理，详情参看 [GraphQL CheatSheet](https://github.com/wx-chevalier/Awesome-CheatSheets/blob/master/Backend/Architecture/Style/GraphQL-CheatSheet.md)。

# 杂谈

今年年初的时候完成了跳槽，换了个吃饭的地方。即有意料之中，也有意料之外。不过自我的主观情绪确实是有很大的波动，工作的压力，自我的迷茫，更加地勤奋与分秒必争。也会要去关注主要矛盾，不能为，那些重要但是仍为支路，或者无法以主观愿望为转移的事务，过多的倾入情感，平滑这些压力或者挫折；**不断地自我学习，关注行业变化**。

这个冬天真的很冷，都冻掉了几层皮,希望来年能温暖一些吧。几年前从创业开始踏入社会，称兄道弟者多，能互称 SD 者少，确实很开心能在新的岗位碰到一群 **SD**。下半年在新工作岗位上愈发忙碌，写字的时间都少了；有时候也会感慨，愈忙碌，越懒惰，越不能专注与坚持，忙忙碌碌，碌碌无为。

- 阅读、记录、整理、编码，在工作的主航道之外还有些通幽曲径，让自己休憩释怀。竞争意识会降低竞争力，使你局限在某个困境或者泥潭中，从而忘记自己的规划与目标。

- 思考与执行分离，充分讨论，坚决执行。使用番茄工作法 过多的碎片化信息反而会带来副作用；求全求杂，过多的碎片化工作也很难带来可感的成就感或者可度量的成长。

- 我的编程能力不行，所以希望提升编程能力。编程能力是提升研发效能的重要保障，对于笔者而言，良好编程能力的外在表现是能够随时随地用合适的语言无阻塞地实现某些功能需求。

今年恰好是上一个三年的结束，得失兼有；希望下一个三年，**不负韶华不负卿**。希望明年，我能继续前行，不再懒惰，能做些有趣的事；有目的的，批量地处理事情，无论是工作，娱乐(刷朋资讯，看漫画)都应该专注地去做。
