# 人月神话

举个例子：在软件项目管理中有一个词叫“人月”，“人”就是一个人、两个人的人，“月”就是一个月、两个月的月。所谓“人月”，就是一个人在一个月内所能完成的工作量。假设某个项目预估需要12个人月，那么你就算了，如果指派4个人来做这个项目，理论上需要3个月；而如果指派6个人来做这个项目，理论上则只需要2个月便可以完成。

你看，这就是用一个简单的数量模型，来控制一个复杂工程。很多公司在做软件工程项目的时候，就是这么计算人力和时间投入的。但是，干过软件工程的人都知道，这么算，是很荒谬的。

程序员的世界里，有一本很经典的书，就叫《人月神话》，就是在驳斥这种算法。
这本书的作者是图灵奖的得主布鲁克斯。他的意思是，软件开发，工程庞大，又非常复杂。我们人类对于这种项目，通常是分工合作，因为它促进效率，节省时间的。但是，随着一个项目参与的人越来越多，分工越来越细，人和人之间需要的沟通量，也指数增长。很快你会发现，沟通花费的时间，渐渐地就比分工省下来的时间还要多。说白了，过了一个临界点，人越多不是越帮忙，而是人越多越添乱。一个人12个月能完成的事，不见得上12个人1个月就能完成，甚至12个月也未必能完成。
所以，《人月神话》这本书里建议了一种组织方式，叫“外科手术式的队伍”。就像一台外科手术一样，有一个主刀大夫，软件项目也应该有一个首席程序员，其他人都是给他提供支持的。这样，就既能获得由少数头脑产生的产品完整性，又能得到多位协助人员的总体生产率，还彻底地减少了沟通的工作量。

你看，关键人，关键支点，在复杂系统中的位置越来越重要了。无论是主刀大夫还是首席程序员。

类似的误区，我们还可以看到很多。比如，有些公司，他们真的认为一头大象可以坐在它任何它想坐的地方，他们真的相信通过砸钱砸人就可以进入任何一个想染指的领域，但很多情况都会失败。这是一种“人月神话”。老喻就举了一个例子：2010年，Facebook做了一个职业社交网站，这是冲着这个领域的老大领英来的。Facebook想的很简单啊。我有的是流量，也不缺钱，光这个网站就拿到了近5000万美金的投资，怎么算账都能赢。果然，通过导流，该个职业社交网站的用户迅速增长到了2500万。但是然后呢？过不了多久，Facebook就只好认输，以200万美金加上一点股份，就把这个网站处理掉了。你看，Facebook，是社交网站，世界第一大，它做职业社交，简直就是一墙之隔，居然就做不成。为啥？其实就是我们今天说的这个效应，他们相信人月神话，相信总体上的数量可以取代关键点上的质量。

人月神话的本质是啥？是我们在简单社会养成的一种思维模式。我们以为，数量优势，即使不是绝对优势，也至少是个全面优势。但是，进入现代复杂社会之后，这个逻辑不再成立。问题不在于你是不是有优势，而在于你是不是知道：哪里才是关键局部？什么才是关键优势？