# 流动与免费

KK（凯文·凯利）认为，因为信息的流动性加强，所以可复制性也随之而来，“免费”成为不可避免的必然趋势。比如很多付费的电影、音乐、图书，在网络上往往能够搜到免费的资源，只要信息在网上传播，迟早会被复制。但是，有8种比“免费”更好的特征会是未来能够产生商业价值的方向，这些特征的商业价值并不会因为信息的可复制性就减弱，反而会因为可复制性而增强。

## 1. 及时性 （Immediacy）

所谓及时性，即比别人更早得到的权利、时效性。 简单来说，就是“我虽然能够免费看，但我等不及想早点看到”。早一步比别人享受新的产品或服务、获取到新的信息，意味着先人一步、抢占先机，这样的权利和待遇甚至会让人产生优越感，无形中产生鄙视链。目前中国互联网市场上，利用这一特征设计产品功能或服务的平台比比皆是，比如优酷、爱奇艺、哔哩哔哩等在线视频应用都会向用户提供付费会员的服务，购买会员服务的用户能够比普通用户提早看到更多的视频和更新内容，利用用户无法等待的心理，吸引用户购买会员服务。爱奇艺在买下盗墓笔记的网络剧版权之后，在自己的平台上免费播放，但是会员与非会员享用这一资源的待遇却不同，非会员只能以一周一更的节奏观看，付费会员则可以立即看全集，很多非会员用户在看后面的内容时，甚至能看到部分会员留下的“炫耀”弹幕：“留下花钱的痕迹”。当你还在一周又一周地等待网络上更新的新资源时，当你看完本周内容还想要看更多的内容时，你还能等下去吗？我想大部分用户都会忍不住地购买会员服务。

## 2. 个性化服务（Personalization）

个性化服务就是差异化服务，即针对不同用户的特殊需求提供的对口服务。 简单来说，即“我虽然能免费关注机构提供的信息和服务，但我有更一些非大众化的需求是这些普适性的信息无法满足的，因此想要针对我的、更个性化的信息和服务”。从线下来看，图书馆开展的参考咨询服务就是在利用这一特征。即通过图书馆将用户与相关领域的专家建立联系，针对用户的问题和需求给出专业化的信息和服务。从线上来看，我想最常见的个性化服务应该就是各大电商平台的推荐系统了吧。平台用户的各项操作行为数据，包括购买行为、收藏行为、点击行为、加车行为、浏览行为等等，都会上报至数据库进行存储，通过对这部分大数据的分析，使得系统“懂得”用户近期的喜好和关注点，想用户推荐你真正“感兴趣或喜欢”的商品，增强订单转化率。线上另外一种提供个性化服务的产品模式与图书馆开展的线下参考咨询服务非常类似，即在行一类的在线问答App。假设用户关注了某个行业领域的专家A，每天看他发布和更新的文章、专栏均是免费的，但是这些都是专家A想要发布的内容，也许没办法解决你当下遇到的一些难题。当你有一些很特殊、很差异化的问题时，就需要付费获取与专家A一对一的咨询机会，以获得能够解决当前问题的信息和方法。

## 3. 增值服务（Interpretation）

这个点我想大家也不陌生，即“我虽然能免费试用和体验产品和服务，但是我想要更多、更好的服务”。也就是说，购买服务或产品的花费正在变小，而产品和服务的价值在于其后续提供的售后服务、技术支持和维护等等，这些成为了产品和服务新的盈利点。这一特征我想在各大手机应用下载平台上并不少见，拿苹果公司的App Store来说，上面有一部分的应用是免费下载的，但是在应用的介绍页会提示“App内购买项目” ，这个提示的意思即告知用户该App内有提供增值服务，可以是游戏道具，也可以是部分高级功能，还可以是会员服务。

## 4. 品质/体验保障（Authenticity）

即“我虽然能免费，但是这样的产品或服务体验是十分糟糕的，我愿意付费获得更优质、更舒适的体验”。这个做法其实在很早以前的餐饮行业里就出现过，并一直延续到今天。餐厅和酒楼其实有大厅和雅间两种就餐位置，大厅往往过于嘈杂，但是却没有保底消费；而雅间则更安静、更适合谈事情，但是消费金额有最低限度。线上利用这一特征设计产品和服务的App也比比皆是，比如有些App会对接一些广告商在应用内推送广告，但是你可以通过付费成为会员而享受更加纯净的无广告模式。

 ## 5. 易获取（Accessibility）

这一点特征可以理解为“更容易获取和使用”，即“我虽然可以免费地整理和存储它们，但是我更希望能随时随地方便地获取它们”。目前市场上很多云端服务就是利用这一特征提供服务，例如百度云盘、微云等等，我们可以将自己的数据和资源保存至云端，并在有需要时下载到本地进行使用即可（当然前提是你要有网路和云端App）。另外，kindle电子书市场上的交易也是如此，付费成功后，kindle还会为你存储副本，方便你随时从云端下载查看。

## 6. 实体化（Embodiment）

关于这一点，我们可以将其理解为免费服务延伸出来的各种周边经济。比如说日本的虚拟歌姬——初音未来，其优美的声音和精美可爱的形象，让其一诞生就俘获了大批宅男的芳心，甚至还借助AR技术举办了多场演唱会，发布了多首单曲，吸引了大量粉丝的支持和喜爱，更不用说一些实体化的人偶、卡贴、海报、游戏等等，这些都是“实体化”的产物。另外一个典型的例子就是逻辑思维，这个团队运营的公众号、网上发布的自媒体视频以及音频节目都是免费的，但是想要线下参加他们的一场演讲却需要购买昂贵的门票。

## 7. 打赏（Patronage） 

这一点我想大家都不陌生，关于这一特征的商业价值已经被中国互联网市场发挥得淋漓尽致，微信公众号、文字社区、直播间等各大平台都支持打赏功能。即“我虽然可以免费成为他们的粉丝，但我喜欢能够付费表达我的赞赏和喜爱。” 如果说实体化只是粉丝经济的一个侧面，那么打赏就是真正地利用粉丝的喜爱来创收了。除了上述提到的逻辑思维，普通的网红也可以通过新浪微博、微信公众号、直播秀场的打赏功能来盈利。 目前风靡全国的各种视频直播平台的主播，从来没有哪个是收费才能观看的，而是免费观看中，吸引粉丝做出打赏行为。

## 8. 可发现性（Discoverability）

可发现性，也可以理解为引导、推荐或发现，即“我虽然可以免费自己筛选信息，但我希望能够付费让别人帮我筛选和推荐。”这是嫁接在免费服务之上的，目前的新闻、视频、音乐以及各种信息都是免费的，但是在这么多海量的信息里面，如何快速发掘出真正对“我”有价值的信息本身就是一件十分有价值的事情。目前互联网的飞速发展导致人们身边的信息指数级的增长，信息污染或是信息过剩的现象逐渐引起了人们的关注，人们往往会付出更大的精力和时间面对每天的信息筛选和利用问题。目前今日头条、网易新闻等新闻App都会利用人们的浏览、点击以及分享行为数据进行个性化推荐服务，每个人看到的内容可能都是不一样的。蘑菇街、礼物说、豆瓣东西等导购型的应用，也在利用这一特征解决用户痛点。这是一个很大的趋势，以前网络上充斥着大量大而全的门户网站，人们认为这是最有价值的；但是现在大家认为谁能帮我选出最符合我口味的优质内容和信息，才是最有价值的。总结凯文·凯利是一个未来学家，他一直致力于通过观察自然发展的规律来预测人类社会的未来发展趋势。从上述提到的八个特征来看，他的预测趋势还是相当准确的，这是因为他以地球上这条长达三十多亿年的逻辑演化链条为研究材料，用研究生物演变和进化的视角来看待我们这个社会科学技术的进步的。马克·吐温曾经说过，历史不总是重复，但它总是押韵。所以，KK是将科技看做了一种生物，因此才能正确预知事物的发展方向。另外，我想大家也不难发现，上述八点特征我们都能看懂，甚至很容易地我在中国互联网市场上想到相关的一些产品和服务，我们已经在身体力行了。但是这并不意味着KK的预测有所倒退，而是中国进步了，我们正在日益变得强大，走在时代前沿。中国正处于这一伟大时代的舞台中央，为其他的发展中国家提供中国智慧和中国方案，我们不光在迎接未来，还在亲手打造未来，也许我们也正在成为趋势。
